>From 5468ce4af6dff2398bf10ad864808131ffb16ca9 Mon Sep 17 00:00:00 2001
From: unknown <Amos@.(none)>
Date: Mon, 7 Jun 2010 11:16:12 +0300
Subject: [PATCH 6/8] remove vmware run from registry

---
 lib/Sys/VirtV2V/Converter/Windows.pm |   65 +++++++++++++++++++++++++++++++++-
 1 files changed, 64 insertions(+), 1 deletions(-)

diff --git a/lib/Sys/VirtV2V/Converter/Windows.pm b/lib/Sys/VirtV2V/Converter/Windows.pm
index dfc52d7..c7f91ff 100644
--- a/lib/Sys/VirtV2V/Converter/Windows.pm
+++ b/lib/Sys/VirtV2V/Converter/Windows.pm
@@ -194,7 +194,9 @@ sub _preconvert
                      $transfer_mount);
     
     _update_system_registry ($g, $tmpdir, $desc, $devices, $config,
-                             $transfer_mount);                 
+                             $transfer_mount);
+    _update_software_registry ($g, $tmpdir, $desc, $devices, $config,
+                             $transfer_mount);                                            
                              
 }
 
@@ -237,6 +239,67 @@ sub _update_system_registry
 
 }
 
+sub _update_software_registry
+{
+    my $g = shift;
+    my $tmpdir = shift;
+    my $desc = shift;
+    my $devices = shift;
+    my $config = shift;
+    my $transfer_mount = shift;
+     
+    # Locate and download the software registry.
+    my $software_filename;
+    eval {
+        $software_filename = "/windows/system32/config/software";
+        $software_filename = $g->case_sensitive_path ($software_filename);
+        $g->download ($software_filename, $tmpdir . "/software");
+    };
+    if ($@) {
+        die (user_message (__x"Could not download the SOFTWARE registry from this Windows guest.  The exact error message was: {errmsg}",
+                           errmsg => $@));
+    }
+  # Open the registry hive.
+    my $software_h = Win::Hivex->open ($tmpdir . "/software", write => 1)
+        or die "open software hive: $!";
+        
+    _remove_vmware_registry_run ($software_h, $desc);    
+        
+    $software_h->commit (undef);
+    undef $software_h;  
+      
+  # Upload the new registry.
+    $g->upload ($tmpdir . "/software", $software_filename);                              
+}
+
+sub _remove_vmware_registry_run
+{
+    my $h = shift;
+    my $desc = shift;
+    
+    # Make the changes.
+    my $regedits = '
+[HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Run]
+"VMware Tools"=-
+"VMware User Process"=-
+';
+    
+    my $io = IO::String->new ($regedits);
+    
+    local *_map = sub {
+       if ($_[0] =~ /^HKEY_LOCAL_MACHINE\\SOFTWARE(.*)/i) {
+         return ($h, $1);
+       } else {
+           die "can only make updates to the SOFTWARE hive (key was: $_[0])\n"
+       }
+    };
+       
+    reg_import ($io, \&_map);
+       
+}
+
+    
+
 # See http://rwmj.wordpress.com/2010/04/30/tip-install-a-device-driver-in-a-windows-vm/
 sub _add_viostor_to_registry
 {
-- 
1.6.1.9.g97c34

